﻿Imports System.Data.EntityClient
Imports System.Data.Objects
Module Module1

  Sub Main()
    ObjectQuerySimpleQuery()
    'EntityCLientSImpleQuery()
    'DMLStoredProcTest()
    'CompiledQueryTest()
    'LinqToEntitiesMergeTest()
    'queryabletests()
    manytomanytest()
    EntitySQLDynamicFields()
  End Sub
  Private Sub LinqtoEntitiesSImpleQuery()
    Using context = New AdventureWorksLTEntities
      Dim query = From detail In context.SalesOrderDetail _
                  Where detail.SalesOrderHeader.TotalDue > 1000 _
                  And detail.UnitPriceDiscount > 0 _
                   Select New With {.ID = detail.SalesOrderHeader.SalesOrderID, detail.SalesOrderHeader.AccountNumber, _
                  detail.SalesOrderHeader.TotalDue, detail.UnitPrice, detail.UnitPriceDiscount, detail.LineTotal}

      Dim qlist = query.ToList
    End Using

  End Sub
  Private Sub ObjectQuerySimpleQuery()
    Using context = New AdventureWorksLTEntities

      Dim eSQL = "SELECT " & _
                 "detail.SalesOrderHeader.SalesOrderID as ID, " & _
                 "detail.SalesOrderHeader.AccountNumber," & _
                 "detail.SalesOrderHeader.TotalDue, " & _
                 "detail.UnitPrice," & _
                 "detail.UnitPriceDiscount, detail.LineTotal " & _
       "FROM AdventureWorksLTEntities.SalesOrderDetail as detail " & _
        "WHERE detail.SalesOrderHeader.TotalDue > 1000  And detail.UnitPriceDiscount > 0 "
      Dim query = context.CreateQuery(Of System.Data.Common.DbDataRecord)(eSQL)

      Dim qlist = query.ToList
    End Using

  End Sub
  Private Sub EntityCLientSImpleQuery()
    Dim eSQL = "SELECT " & _
               "detail.SalesOrderHeader.SalesOrderID as ID, " & _
               "detail.SalesOrderHeader.AccountNumber," & _
               "detail.SalesOrderHeader.TotalDue, " & _
               "detail.UnitPrice," & _
               "detail.UnitPriceDiscount, detail.LineTotal " & _
     "FROM AdventureWorksLTEntities.SalesOrderDetail as detail " & _
      "WHERE detail.SalesOrderHeader.TotalDue > 1000  And detail.UnitPriceDiscount > 0 "
    Using eConn As New EntityClient.EntityConnection("Name=AdventureWorksLTEntities")
      Dim eComm As New EntityCommand(eSQL, eConn)
      eConn.Open()
      Dim dr = eComm.ExecuteReader(CommandBehavior.SequentialAccess)
      For Each dbrec As System.Data.Common.DbDataRecord In dr
        Console.WriteLine("Account #: {0}," & _
                          " Unit Price Discount: {1}", _
                          dbrec.Item("AccountNumber"), dbrec.Item(4))
      Next


    End Using
  End Sub
  Private Sub EntitySQLDynamicFields()
    Dim arrayOfFields = New String() _
          {"FirstName", "LastName"}
    Dim strFlds As New Text.StringBuilder
    For Each fld In arrayOfFields
      strFlds.Append("c." & fld & ",")
    Next
    'trim off last comma
    strFlds.Remove(strFlds.Length - 1, 1)

    Dim queryString = _
     "SELECT " & strFlds.ToString & _
     " FROM AdventureworksLTEntities.Customers AS c" & _
     " WHERE LEFT(c.lastname,1)='S'"
    Using context As New AdventureWorksLTEntities
      Dim query = context.CreateQuery(Of System.Data.Common.DbDataRecord)(queryString)
      Dim qlist = query.ToList
    End Using
  End Sub

  Private Sub DMLStoredProcTest()
    'updatecustomer happens to have parameters that match a cusotmer entity
    'and could be mapped directly to the customer entity, but instead,
    'I want to test calling it manually
    Dim cust As Customers
    Using context = New NWEntities
      'get a customer
      Dim custquery = From c In context.Customers Select c
      cust = custquery.First
    End Using
    cust.CompanyName = cust.CompanyName.Trim & "____XYZ"
    'update using stored proc. Sine my sproc has no return value I can only use it thorugh EntityClient
    Using eConn As New EntityClient.EntityConnection("Name=NWEntities")
      Dim eComm As New EntityCommand("NWEntities.UpdateCompanyName", eConn)
      eComm.CommandType = CommandType.StoredProcedure
      eComm.Parameters.AddWithValue("CustomerID", cust.CustomerID)
      eComm.Parameters.AddWithValue("CompanyName", cust.CompanyName)
      'other values required
      eConn.Open()
      eComm.ExecuteNonQuery()
    End Using
  End Sub
  Private Sub CompiledQueryTest()
    Dim compQuery = CompiledQuery.Compile(Of AdventureWorksLTEntities, Decimal, IQueryable(Of SalesOrderHeader))( _
            Function(ctx As AdventureWorksLTEntities, total As Decimal) _
                From order In ctx.SalesOrderHeader _
                Where (order.TotalDue >= total) _
                Select order)

    Dim totalDue As Decimal = 200.0



    For i = 1 To 10
      Dim AWEntities As New AdventureWorksLTEntities

      Dim orders As ObjectQuery(Of SalesOrderHeader) = compQuery.Invoke(AWEntities, totalDue)
      Dim w As New Stopwatch
      w.Start()

      'Dim orders As IQueryable(Of SalesOrderHeader) = From order In AWEntities.SalesOrderHeader _
      'Where (order.TotalDue >= totalDue) _
      'Select order

      Dim o = orders.ToList
      w.Stop()
      Console.WriteLine(w.ElapsedMilliseconds)
      orders = Nothing

      AWEntities = Nothing
      w.Reset()
    Next i
  End Sub
  Private Sub LinqToEntitiesMergeTest()
    Using aw = New AdventureWorksLTEntities
      Dim linqquery = From c In aw.Customers Select c
      Dim objquery = CType(linqquery, ObjectQuery(Of Customer))
      objquery.MergeOption = MergeOption.OverwriteChanges
      Dim custs = linqquery.ToList
      Dim cust = custs.First
      Console.WriteLine(cust.LastName)
      cust.LastName = cust.LastName.Trim & "___XYZ"
      custs = linqquery.ToList
      cust = custs.First
      Console.WriteLine(cust.LastName)

    End Using
  End Sub
  Private Sub queryabletests()
    Using context As New AdventureWorksLTEntities


      Dim query = From c In context.Customers Where c.LastName.StartsWith("S")
      Dim objquery = CType(query, ObjectQuery(Of Customer))
      objquery.MergeOption = MergeOption.OverwriteChanges
      Dim custs = objquery.Execute(MergeOption.OverwriteChanges)
      Dim cust = query.ToList.First
      Console.WriteLine(cust.LastName)
      cust.LastName = cust.LastName.Trim & "___XYZ"
      cust = query.ToList.First
      Console.WriteLine(cust.LastName)


    End Using
  End Sub

  Private Sub manytomanytest()
    Using context = New NWEntities
      Dim query = From cust In context.Customers Where (cust.CustomerDemographics.Any(Function(cd) cd.CustomerDesc.Contains("abcd")))
      Dim ql = query.ToList

    End Using
  End Sub
End Module
