﻿Imports System.Data.Linq

Module Module1

  Sub Main()
    SimpleLINQQuery()
    TPHQuery()
    LinqInsert()
    CompiledQueryTest()

  End Sub
  

  Private Sub SimpleLINQQuery()
    Dim context = New AWModelDataContext

    Dim query = From detail In context.Details _
                Where detail.Order.TotalDue > 1000 _
                And detail.UnitPriceDiscount > 0 _
                 Select New With {.ID = detail.Order.SalesOrderID, detail.Order.AccountNumber, _
                   detail.Order.TotalDue, detail.UnitPrice, detail.UnitPriceDiscount, detail.LineTotal}

    Dim qlist = query.ToList
  End Sub
  Private Sub LinqInsert()
    Dim order = New Order
    With order
      .AccountNumber = "12345"
      .CustomerID = 11
      .DueDate = DateAdd(DateInterval.Month, 1, Now)
      .SalesOrderNumber = "123"
      .OrderDate = Now
      .BillToAddressID = 446
      .Freight = 10
      .TotalDue = 100
      .SubTotal = 80
      .TaxAmt = 10
      .ModifiedDate = Now
      .rowguid = Guid.NewGuid
      .ShipToAddressID = 446
      .ShipMethod = "Pony Express"
      .OrderDate = Now()

    End With
    Dim detail = New Detail
    With detail
      .OrderQty = 2
      .ProductID = 709
      .Order = order
      .UnitPrice = "24.99"
      .UnitPriceDiscount = 0
      .rowguid = Guid.NewGuid
      .ModifiedDate = Now()
    End With

    Dim detail2 = New Detail
    With detail2
      .OrderQty = 5
      .ProductID = 732
      .Order = order
      .UnitPrice = "4.99"
      .UnitPriceDiscount = 0
      .rowguid = Guid.NewGuid
      .ModifiedDate = Now
    End With

    Using context = New AWModelDataContext
      context.Orders.InsertOnSubmit(order)
      context.SubmitChanges()
    End Using

  End Sub
  Private Sub TPHQuery()
    Dim context = New AWModelDataContext

    Dim query = From weborder In _
                context.Orders.OfType(Of WebOrder)() _
                Select weborder

    Dim qlist = query.ToList
    Dim wo = qlist(1)
    Dim newwo = New WebOrder
    With newwo
      .AccountNumber = wo.AccountNumber
      .CustomerID = wo.CustomerID
      .DueDate = DateAdd(DateInterval.Month, 1, Now)
      .SalesOrderNumber = "123"
      .OrderDate = Now
      .BillToAddressID = wo.BillToAddressID
      .Freight = 10
      .TotalDue = 100
      .SubTotal = 80
      .TaxAmt = 10
      .ModifiedDate = Now
      .rowguid = Guid.NewGuid
      .ShipToAddressID = wo.ShipToAddressID
      .ShipMethod = wo.ShipMethod

    End With
    context.Orders.InsertOnSubmit(newwo)
    context.SubmitChanges()

  End Sub
  Private Sub CompiledQueryTest()

    Dim context = New AWModelDataContext
    Dim sw = New Stopwatch
    For i = 1 To 10
      sw.Reset()
      sw.Start()
      'Dim orderquery = Queries.compiledOrders(context, 200)
      Dim orderquery = From order In context.Orders Where (order.TotalDue >= 200) Select order
      Dim orders = orderquery.ToList
      sw.Stop()
      Console.WriteLine(sw.ElapsedMilliseconds)
    Next i
  End Sub

End Module
Class Queries
  'Public Shared CustomersByCity As  _
  '     Func(Of AWModelDataContext, String, IQueryable(Of Customer)) = _
  '         System.Data.Linq.CompiledQuery.Compile(Function(db As AWModelDataContext, _
  ' city As String) _
  '     From c In db.Customers Where c.City = city Select c))

  
  Public Shared compiledOrders As  _
      Func(Of AWModelDataContext, Integer, IQueryable(Of Order)) = _
         CompiledQuery.Compile(Function(context As AWModelDataContext, total As Integer) _
   From order In context.Orders Where (order.TotalDue >= total) Select order)



  'Public Shared CustomersById As  _
  '    Func(Of Northwnd, String, IQueryable(Of Customer)) = _
  '        CompiledQuery.Compile(Function(db As Northwnd, _
  'id As String) _
  '    db.Customers.Where(Function(c) c.CustomerID = id))
  'Dim compQuery = CompiledQuery.Compile(Of AdventureWorksLTEntities, Decimal, IQueryable(Of SalesOrderHeader))( _
  '          Function(ctx As AdventureWorksLTEntities, total As Decimal) _
  '              From order In ctx.SalesOrderHeader _
  '              Where (order.TotalDue >= total) _
  '              Select order)
  Public Shared Sub sproctest()
    Dim context As New AWModelDataContext
    Dim q = context.CustomerOrders(16)
    Dim order = q.FirstOrDefault
  End Sub

End Class
